#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <net/ethernet.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <arpa/inet.h>

#include "pktlib.h"
#include "pktbuf.h"
#include "arplib.h"

static char *make_srcmacaddr(in_addr_t ipaddr)
{
  static char macaddr[ETHER_ADDR_LEN];
  ipaddr = htonl(ipaddr);
  macaddr[0] = 0x00;
  macaddr[1] = 0x11;
  memcpy(&macaddr[2], &ipaddr, sizeof(in_addr_t));
  return macaddr;
}

int main(int argc, char *argv[])
{
  pktif_t pktif;
  pktbuf_t pktbuf;
  arptbl_t arptbl;
  in_addr_t my_ipaddr;

  /* 󥿡ե򥪡ץ󤹤(ȯѥåȤϼʤ) */
  pktif = pktif_open(argv[1], PKTIF_OPEN_FLAG_RECV_NOTSENT, 0);
  my_ipaddr = ntohl(inet_addr(argv[2])); /* IPɥ쥹 */

  arptbl = arplib_table_create(my_ipaddr, make_srcmacaddr(my_ipaddr));

  while (1) {
    pktbuf = pktbuf_recv(pktif, 0); /* ѥåȤ */
    if (pktbuf == NULL) continue;
    pktbuf = arplib_packet_proc(arptbl, pktbuf);
    pktbuf = pktbuf_send_queue(pktif, pktbuf); /* ʣѥåȤ */
    pktbuf_destroy_queue(pktbuf);
  }

  return 0;
}
